Attribute VB_Name = "Module1"
Type MUC_Type
    opcode As String * 4
    AMode As String * 1
    Register As String * 2
    CFlag As String * 1
    OFlag As String * 1
    Operation As String * 1
End Type

Public Data_Array(7) As Integer
Public Adres_Array(11) As Integer
Public Led_Array(7) As Integer
Public Fled_Array(2) As Integer
Public Run_Flag As Integer
Public Ram_Array(4095, 1) As Integer
Public Bin_Array(11) As Integer

Public Reg_Accu As Integer
Public Reg_Status As Integer
Public Reg_Extension As Integer
Public Reg_P0 As Integer
Public Reg_P1 As Integer
Public Reg_P2 As Integer
Public Reg_P3 As Integer

Public Homepath$
Public MUC(255) As MUC_Type
Public SStep_Flag As Integer
Public Halt_Flag As Integer
Public Display_Cleared As Integer
Public Trace_Flag As Integer
Public Xff%, TimeOutVal%, TimeCount%, Tx%
Public Halt_Test As Integer
'for readabitity




Sub Fetch(m1 As Integer, m2 As Integer)
        
        Reg_P0 = Reg_P0 + 1
        If Reg_P0 > 4095 Then
            Reg_P0 = 0
        End If
        m1 = Get_Ram%(Reg_P0)
        If (m1 And 128) > 0 Then
            Reg_P0 = Reg_P0 + 1
            If Reg_P0 > 4095 Then
                Reg_P0 = 0
            End If
            m2 = Get_Ram%(Reg_P0)
        Else
            m2 = -1
        End If
        
End Sub

Function Get_Ram%(CurAd As Integer)

        If (CurAd > 4095) Or (CurAd < 0) Then
            Get_Ram% = &H55
            Exit Function
        End If
        Rstat% = Ram_Array(CurAd, 1)
        Select Case Rstat%
            Case 0
                ' normal RAM
                Get_Ram% = Ram_Array(CurAd, 0)
            Case 1
                ' Led output
                Get_Ram% = 255
            Case Else
                ' Non Aviable
                Get_Ram% = &HFE
        End Select
        
End Function
Sub Put_Ram(CurAd As Integer, CurDb As Integer)
        
        If (CurAd > 4095) Or (CurAd < 0) Then
            Exit Sub
        End If
        Rstat% = Ram_Array(CurAd, 1)
        Select Case Rstat%
            Case 0
                ' normal RAM
                Ram_Array(CurAd, 0) = CurDb
            Case 1
                ' Led output
                Dbres% = CurDb
                For i% = 0 To 7
                    If (CurDb Mod 2) = 1 Then
                        Led_Array(i%) = True
                    Else
                        Led_Array(i%) = False
                    End If
                    If Led_Array(i%) Then
                        With frm_SCMPBRD
                           .Led_Off(i%).Visible = False
                           .Led_On(i%).Visible = True
                           .Led_On(i%).Refresh
                        End With
                    Else
                        With frm_SCMPBRD
                           .Led_Off(i%).Visible = True
                           .Led_On(i%).Visible = False
                           .Led_Off(i%).Refresh
                        End With
                    End If
                    CurDb = CurDb \ 2
                Next
                CurDb = Dbres%
            Case Else
                ' Non Aviable
        End Select
        
End Sub
Function HEX2$(b%)

        c$ = Hex$(b%)
        If Len(c$) < 2 Then
            c$ = "0" + c$
        End If
        HEX2$ = c$
        
End Function
Function HEX4$(b%)

        c$ = Hex$(b%)
        Do While Len(c$) < 4
            c$ = "0" + c$
        Loop
        HEX4$ = c$
        
End Function
Sub Parse(OPC As Integer, OPR As Integer)

    OPCstring$ = RTrim$(MUC(OPC).opcode)
    If OPR >= 0 Then
        ' Parse Double Byte Instructions
        
        ' If Left$(OPCstring$, 1) = "J" Then
            ' Do a Branch or Jump instruction
            ' Branch OPC, OPR, OPCstring$
        ' End If
        Select Case OPCstring$
            ' given the fact that "Select Case" Cases run
            ' faster as they are towards the top op the
            ' construct, The order of testing for OPCODE-
            ' matches must be prioritized according to the
            ' the relative use/importance of the instruction.
            ' So =====> "Jumps First"
            Case "JMP"
                Ea% = CalcPC%(OPC, OPR)
            Case "JP"
                If (Reg_Accu And &H80) = 0 Then
                    Ea% = CalcPC%(OPC, OPR)
                End If
            Case "JZ"
                If Reg_Accu = 0 Then
                    Ea% = CalcPC%(OPC, OPR)
                End If
            Case "JNZ"
                If Reg_Accu <> 0 Then
                    Ea% = CalcPC%(OPC, OPR)
                End If
            Case "LDI"
                Reg_Accu = OPR
            Case "ANI"
                Reg_Accu = OPR And Reg_Accu
            Case "ORI"
                Reg_Accu = OPR Or Reg_Accu
            Case "XRI"
                Reg_Accu = OPR Xor Reg_Accu
            Case "ADI"
                Reg_Accu = Add8Bit%(Reg_Accu, OPR)
            Case "CAI"
                Reg_Accu = Add8Bit%(Reg_Accu, OPC Xor &HFF)
            Case "DAI"
                Reg_Accu = DecAdd8Bit%(Reg_Accu, OPR)
            Case "LDI"
                Reg_Accu = OPR
            Case "ILD"
                Ea% = CalcEA%(OPC, OPR)
                b% = Get_Ram%(Ea%)
                b% = (b% + 1) And &HFF
                Put_Ram Ea%, b%
                Reg_Accu = b%
            Case "DLD"
                Ea% = CalcEA%(OPC, OPR)
                b% = Get_Ram%(Ea%)
                b% = (b% - 1) And &HFF
                Put_Ram Ea%, b%
                Reg_Accu = b%
            Case "LD"
                Ea% = CalcEA%(OPC, OPR)
                Reg_Accu = Get_Ram%(Ea%)
            Case "ST"
                Ea% = CalcEA%(OPC, OPR)
                Put_Ram Ea%, Reg_Accu
            Case "AND"
                Ea% = CalcEA%(OPC, OPR)
                b% = Get_Ram%(Ea%)
                Reg_Accu = RegAccu And b%
            Case "OR"
                Ea% = CalcEA%(OPC, OPR)
                b% = Get_Ram%(Ea%)
                Reg_Accu = RegAccu And b%
            Case "XOR"
                Ea% = CalcEA%(OPC, OPR)
                b% = Get_Ram%(Ea%)
                Reg_Accu = RegAccu And b%
            Case "ADD"
                Ea% = CalcEA%(OPC, OPR)
                b% = Get_Ram%(Ea%)
                Reg_Accu = Add8Bit%(Reg_Accu, b%)
            Case "DAD"
                Ea% = CalcEA%(OPC, OPR)
                b% = Get_Ram%(Ea%)
                Reg_Accu = DecAdd8Bit%(Reg_Accu, b%)
            Case "CAD"
                Ea% = CalcEA%(OPC, OPR)
                b% = Get_Ram%(Ea%)
                Reg_Accu = Add8Bit%(Reg_Accu, b% Xor &HFF)
            Case "DLY"
                For i% = 0 To OPR
                   For n% = 1 To 10000
                   Next
                Next
                For j% = 0 To Reg_Accu
                   For n% = 1 To 40
                   Next
                Next
            Case ""
                'Halt_Flag = True
        End Select
    Else
        ' Parse Single byte instructions
        Select Case OPCstring$
            Case "XPAL"
                Select Case RTrim$(MUC(OPC).Register)
                    Case "P0"
                        t% = Reg_Accu
                        Reg_Accu = GetLowByte%(Reg_P0)
                        PutLowByte Reg_P0, t%
                    Case "P1"
                        t% = Reg_Accu
                        Reg_Accu = GetLowByte%(Reg_P1)
                        PutLowByte Reg_P1, t%
                    Case "P2"
                        t% = Reg_Accu
                        Reg_Accu = GetLowByte%(Reg_P2)
                        PutLowByte Reg_P2, t%
                    Case "P3"
                        t% = Reg_Accu
                        Reg_Accu = GetLowByte%(Reg_P3)
                        PutLowByte Reg_P3, t%
                End Select
            Case "XPAH"
                Select Case RTrim$(MUC(OPC).Register)
                    Case "P0"
                        t% = Reg_Accu
                        Reg_Accu = GetHighByte%(Reg_P0)
                        PutHighByte Reg_P0, t%
                    Case "P1"
                        t% = Reg_Accu
                        Reg_Accu = GetHighByte%(Reg_P1)
                        PutHighByte Reg_P1, t%
                    Case "P2"
                        t% = Reg_Accu
                        Reg_Accu = GetHighByte%(Reg_P2)
                        PutHighByte Reg_P2, t%
                    Case "P3"
                        t% = Reg_Accu
                        Reg_Accu = GetHighByte%(Reg_P3)
                        PutHighByte Reg_P3, t%
                End Select
            Case "XPPC"
                Select Case RTrim$(MUC(OPC).Register)
                    Case "P1"
                        t% = Reg_P1
                        Reg_P1 = Reg_P0
                        Reg_P0 = t%
                    Case "P2"
                        t% = Reg_P2
                        Reg_P2 = Reg_P0
                        Reg_P0 = t%
                    Case "P3"
                        t% = Reg_P3
                        Reg_P3 = Reg_P0
                        Reg_P0 = t%
                End Select
            Case "XAE"
                t% = Reg_Accu
                Reg_Accu = Reg_Extension
                Reg_Extension = t%
            Case "ANE"
                Reg_Accu = Reg_Extension And Reg_Accu
            Case "ORE"
                Reg_Accu = Reg_Extension Or Reg_Accu
            Case "XRE"
                Reg_Accu = Reg_Extension Xor Reg_Accu
            Case "ADE"
                Reg_Accu = Add8Bit%(Reg_Accu, Reg_Extension)
            Case "CAE"
                Reg_Accu = Add8Bit%(Reg_Accu, OPC Xor &HFF)
            Case "DAE"
                Reg_Accu = DecAdd8Bit%(Reg_Accu, Reg_Extension)
            Case "IEN"
                Reg_Status = Reg_Status Or &H8
            Case "DINT"
                Reg_Status = Reg_Status And &HF7
            Case "CCL"
                Reg_Status = Reg_Status And &H7F
            Case "SCL"
                Reg_Status = Reg_Status Or &H80
            Case "CAS"
                Reg_Status = Reg_Accu
                ' Led output
                CurDb = Reg_Status
                For i% = 0 To 2
                    If (CurDb Mod 2) = 1 Then
                        Fled_Array(i%) = True
                    Else
                        Fled_Array(i%) = False
                    End If
                    If Fled_Array(i%) Then
                        With frm_SCMPBRD
                           .F_Led_Off(i%).Visible = False
                           .F_Led_On(i%).Visible = True
                           .F_Led_On(i%).Refresh
                        End With
                    Else
                        With frm_SCMPBRD
                           .F_Led_Off(i%).Visible = True
                           .F_Led_On(i%).Visible = False
                           .F_Led_Off(i%).Refresh
                        End With
                    End If
                    CurDb = CurDb \ 2
                Next
            Case "CSA"
                Reg_Accu = Reg_Status
            Case "NOP", ""
                'do nothing
            Case "SIO"
                'since serial operations cannot be emulated only a
                'right-shift will be operated on the Extension reg.
                Reg_Extension = Reg_Extension \ 2
            Case "SR"
                Reg_Accu = Reg_Accu \ 2
            Case "SRL"
                If (Reg_Status And &H80) Then
                   Reg_Accu = Reg_Accu Or &H100
                End If
                Reg_Accu = Reg_Accu \ 2
            Case "RR"
                tmp% = Reg_Accu Mod 2
                Reg_Accu = Reg_Accu \ 2
                If tmp% Then
                   Reg_Accu = Reg_Accu Or &H80
                End If
            Case "RRL"
                tmp% = Reg_Accu Mod 2
                Reg_Accu = Reg_Accu \ 2
                If (Reg_Status And &H80) Then
                  Reg_Accu = Reg_Accu Or &H80
                End If
                If tmp% Then
                  Reg_Status = Reg_Status Or &H80
                End If
            Case "HALT"
                Halt_Flag = True
                With frm_SCMPBRD
                  .Halt_Led_On.Visible = True
                  .Halt_Led_Off.Visible = False
                End With
        End Select
    End If
End Sub
Function GetLowByte%(b%)

        GetLowByte% = b% And &HFF

End Function
Function GetHighByte%(b%)

        GetHighByte% = Val("&H" + Left$(HEX4$(b%), 2))
        
End Function
Sub PutLowByte(d%, b%)

        hb% = d% And &HFF00
        d% = hb% Or (b% And &HFF)

End Sub
Sub PutHighByte(d%, b%)

       d% = Val("&H" + Right$(HEX4$(b%), 2) + Right$(HEX4$(d%), 2))

End Sub
Function CalcPC%(opcode%, operand%)
        ' Determine if operand must be taken from E-Reg
        If operand% = &H80 Then
            Disp% = Reg_Extension
        Else
            Disp% = operand%
        End If
        ' Determine sign of displacement
        Sign% = Disp% And &H80
        If Sign% > 0 Then
            PutHighByte Disp%, &HFF
        End If
        PReg$ = RTrim$(MUC(opcode%).Register)
        Select Case PReg$
            Case "P0"
                p% = Reg_P0
            Case "P1"
                p% = Reg_P1
            Case "P2"
                p% = Reg_P2
            Case "P3"
                p% = Reg_P4
        End Select
        Ea% = (p% + Disp%) And &HFFF
        Reg_P0 = Ea%
        
End Function
Function CalcEA%(opcode%, operand%)

        ' Determine if operand must be taken from E-Reg
        If operand% = &H80 Then
            Disp% = Reg_Extension
        Else
            Disp% = operand%
        End If
        ' Determine sign of displacement
        Sign% = Disp% And &H80
        If Sign% > 0 Then
            PutHighByte Disp%, &HFF
        End If
        PReg$ = RTrim$(MUC(opcode%).Register)
        Select Case PReg$
            Case "P0"
                p% = Reg_P0
            Case "P1"
                p% = Reg_P1
            Case "P2"
                p% = Reg_P2
            Case "P3"
                p% = Reg_P4
        End Select
        Ea% = (p% + Disp%) And &HFFF
        Am$ = RTrim$(MUC(opcode%).AMode)
        If Am$ = "D" Then
            CalcEA% = Ea%
        ElseIf Am$ = "@" Then
            ' sign of displacement determines pre-decr
            ' or post-inc behaviour for "stack purposes
            If Disp% > 0 Then
                ' Pre decrement (Pointer must change
                ' before EA% is calculated)
                CalcEA% = Ea%
            Else
                ' Post increment (Pointer will reference the
                ' memory. The Pointer will be updated with
                ' calculated EA. Use only the returned Ea%
                ' for memory reference for this instance)
                Select Case PReg$
                    Case "P1"
                        CalcEA% = Reg_P1
                    Case "P2"
                        CalcEA% = Reg_P2
                    Case "P3"
                        CalcEA% = Reg_P4
                End Select
            End If
            Select Case PReg$
                Case "P1"
                    Reg_P1 = Ea%
                Case "P2"
                    Reg_P2 = Ea%
                Case "P3"
                    Reg_P2 = Ea%
            End Select
        End If
                
End Function
Function Add8Bit%(v1%, v2%)
                
                ' This fuction performes the addition of
                ' 2 8Bit signed integer operands and
                ' the carry. Upon addition the Cy and
                ' the ov carry are updated according the
                ' result of the operation.
                
                ' determine current carry
                cy% = Reg_Status And &H80
                If cy% > 0 Then
                    cy% = 1
                Else
                    cy% = 0
                End If
                t% = v1% + v2% + cy%
                ' calculate carry & overflow
                cy% = t% And &H100
                If cy% > 0 Then
                   cy% = 1
                   Reg_Status = Reg_Status Or &H80
                Else
                   cy% = 0
                   Reg_Status = Reg_Status And &H7F
                End If
                b7% = t% And &H80
                If b7% > 0 Then
                    b7% = 1
                End If
                ov% = b7% Xor cy%
                If ov% > 0 Then
                   ov% = 1
                   Reg_Status = Reg_Status Or &H40
                Else
                   ov% = 0
                   Reg_Status = Reg_Status And &HBF
                End If
                Add8Bit% = t% And &HFF

End Function
Function DecAdd8Bit%(t%, v%)
                
                ' This Function Performes a Decimal (BCD)
                ' Add on two BCD-coded bytes. The
                ' Carry is included in the operation and the
                ' resulting carry is updated in the status-reg.
                
                th% = t% And &HF0 \ 16
                tl% = t% And &HF
                ah% = v% And &HF0 \ 16
                al% = v% And &HF
                rl% = tl% + al% + cy%
                If rl% > 9 Then
                    dcy% = 1
                    rl% = rl% - 10
                End If
                rh% = ah% + th% + dcy%
                If rh% > 9 Then
                    cy% = 1
                    rh% = rh% - 10
                End If
                If cy% = 1 Then
                   Reg_Status = Reg_Status Or &H80
                Else
                   Reg_Status = Reg_Status And &H7F
                End If
                DecAdd8Bit% = rh% * 16 + rl%

End Function
Sub Machine_Cycle()

        If Not Run_Flag Then
            Exit Sub
        End If
        Fetch Mem1%, Mem2%
        Parse Mem1%, Mem2%
        If Trace_Flag Then
            tr$ = ""
            If RTrim$(MUC(Mem1%).opcode) = "" Then
               tr$ = "Illegal Instruction (Halt) on:" + HEX2$(Mem1%)
            Else
               tr$ = MUC(Mem1%).opcode + " "
               tr$ = tr$ + MUC(Mem1%).AMode + " "
               tr$ = tr$ + MUC(Mem1%).Register + " "
               tr$ = tr$ + MUC(Mem1%).CFlag + " "
               tr$ = tr$ + MUC(Mem1%).OFlag + " "
               tr$ = tr$ + MUC(Mem1%).Operation + " "
               tr$ = tr$ + HEX4$(Reg_P0) + " "
               tr$ = tr$ + HEX2$(Mem1%) + " "
               If Mem2% < 0 Then
                    tr$ = tr$ + "   "
               Else
                    tr$ = tr$ + HEX2$(Mem2%)
               End If
               tr$ = tr$ + "P0-3: "
               tr$ = tr$ + HEX4$(Reg_P0) + " "
               tr$ = tr$ + HEX4$(Reg_P1) + " "
               tr$ = tr$ + HEX4$(Reg_P2) + " "
               tr$ = tr$ + HEX4$(Reg_P3) + " "
               tr$ = tr$ + "A,EX,ST: "
               tr$ = tr$ + HEX2$(Reg_Accu) + " "
               tr$ = tr$ + HEX2$(Reg_Extension) + " "
               tr$ = tr$ + HEX2$(Reg_Status) + " "
               Print #Xff%, tr$
            End If
        End If
    
        If SStep_Flag Then
            With frm_SCMPBRD
                'clear debug area
                .lbl_P0 = ""
                .lbl_P1 = ""
                .lbl_P2 = ""
                .lbl_P3 = ""
                .lbl_Accu = ""
                .lbl_Extension = ""
                .lbl_Status = ""
                .lbl_m1 = ""
                .lbl_m2 = ""
                'fill debug area
                If LTrim$(MUC(Mem1%).opcode) = "" Then
                    .lbl_Opcode.Caption = " Error"
                    .lbl_Amode.Caption = ""
                    .lbl_Register.Caption = ""
                    .lbl_Cflag.Caption = ""
                    .lbl_OFlag.Caption = ""
                    .lbl_Operation.Caption = ""
                Else
                    .lbl_Opcode.Caption = MUC(Mem1%).opcode
                    .lbl_Amode.Caption = MUC(Mem1%).AMode
                    .lbl_Register.Caption = MUC(Mem1%).Register
                    .lbl_Cflag.Caption = MUC(Mem1%).CFlag
                    .lbl_OFlag.Caption = MUC(Mem1%).OFlag
                    .lbl_Operation.Caption = MUC(Mem1%).Operation
                End If
                .lbl_P0 = HEX4$(Reg_P0)
                .lbl_P1 = HEX4$(Reg_P1)
                .lbl_P2 = HEX4$(Reg_P2)
                .lbl_P3 = HEX4$(Reg_P3)
                .lbl_Accu = HEX2$(Reg_Accu)
                .lbl_Extension = HEX2$(Reg_Extension)
                .lbl_Status = HEX2$(Reg_Status)
                .lbl_m1 = HEX2$(Mem1%)
                If Not (Mem2% < 0) Then
                    .lbl_m2 = HEX2$(Mem2%)
                Else
                    .lbl_m2 = ""
                End If
            End With
        End If
        
End Sub
